#include <stdio.h>
#include <stdlib.h>
#include <string.h>


char * incr_strcat(char **dest, int *index, int *length, const char *source, int incr) {
	int x;
	char *tmp;
	
	if (source == NULL) {
		return *dest;
	}
	
	x = strlen(source);
	
	if (*dest == NULL) {
		*length = x + 1;
		*index = 0;
		tmp = calloc(*length, sizeof(char));
		if (tmp == NULL) {
			fprintf(stderr, "Error. Could not allocate memory. Program will abort now.\n");
			exit(-1);
		}
		*dest = tmp;
	}		
	
	if ( x >= (*length - *index) ) {
		while ( x >= (*length - *index) ) {
			*length += incr;
		}
		tmp = realloc(*dest, (*length) * sizeof(char));
		if (tmp == NULL) {
			fprintf(stderr, "Error. Could not allocate memory. Program will abort now.\n");
			exit(-1);
		}
		*dest = tmp;


	}


	strncpy(*dest + *index, source, *length - *index);
	*index += x;

	return *dest;
}

char * incr_fgets(char **dest, int *length, FILE *source, int incr) {
	int index = 0;
	char *tmp;
	
	if (*dest == NULL) {
		*length = incr;
		tmp = calloc(*length, sizeof(char));
		if (tmp == NULL) {
			fprintf(stderr, "Error. Could not allocate memory. Program will abort now.\n");
			exit(-1);
		}
		*dest = tmp;
	}		


	while ( 1 ) {
		tmp = fgets(*dest + index, *length - index, source);
		
		if (tmp == NULL) {
			return NULL;
		}
		
		if ( (*dest)[*length - 2] != '\n' && (*dest)[*length - 2] != '\0') {
			index = *length - 1;
			*length += incr;
			tmp = realloc(*dest, *length * sizeof(char));
			if (tmp == NULL) {
				fprintf(stderr, "Error. Could not allocate memory. Program will abort now.\n");
				exit(-1);
			}
			*dest = tmp;
			(*dest)[*length - 2] = '\0';
		} else {
			break;
		}
	}
	
	
	return *dest;
}
