#ifndef INCR_STRING
#define INCR_STRING

/*
 * Appends string source at the index of dest, increasing memory allocation if needed.
 *
 * length should be a pointer to the currently allocated amount (which will be updated)
 * index should be a pointer to an index for appending at the location (will be updated)
 * incr is the desired amount to increment with
 */
char * incr_strcat(char **dest, int *index, int *length, const char *source, int incr);

/*
 * Reads from source to dest, increasing memory allocation if needed.
 */
char * incr_fgets(char **dest, int *length, FILE *source, int incr);


#endif
