#ifndef SPEX_SET
#define SPEX_SET

#include "spexRange.h"

typedef struct set_elt {
	DRangeP elem;
	struct set_elt *next;
} DSet;	

typedef DSet * DSetP;

extern const DSetP emptySet;

DSetP	SetMakeEmpty();
char	SetIsEmpty(DSetP);
char	SetContains(DSetP, DRangeP);
DSetP	SetIntersect(DSetP, DSetP);
// TODO? DSetP	SetDifference(DSetP, DSetP);
DSetP	SetUnion(DSetP, DSetP);
DSetP	SetRemove(DSetP setA, DSetP setB);


// Searches the set for a range element, for which the function 'cmp' returns true.
// If it finds such an element, it returns the first element that does. Otherwise the function returns NULL.
DRangeP	SetFind(DSetP set, char cmp(DRangeP));
// Maps the function 'fcn' on every range element. If 'fcn' returns NULL for an
// element, this element will not be added to the resulting set.
DSetP	SetMap(DSetP set, DRangeP fcn(DRangeP));
int	SetCmp(DSetP, DSetP);
char	SetEq(DSetP, DSetP);

DSetP	SetMakeSingle(DRangeP);
DSetP	SetMakeArray(DRangeP[], int);
DSetP	SetMakeFromString(const char *);

DSetP	SetInsertElem(DSetP, DRangeP);	// Sorted insert
DSetP	SetInsertArray(DSetP, DRangeP[], int);

void	SetPrint(DSetP);
char *	SetToString(DSetP);

int	SetIsSane(DSetP);
DSetP	SetSanitize(DSetP set);

DRangeP	SetGetFirst(DSetP);
DSetP		SetGetRest(DSetP);

//DRangeP	SetDropFirst(DsetP);

void	SetFree(DSetP set);

int	SetSize(DSetP);

#endif
