# =========================================================================
#
# $Id: guide.tcl,v 1.1.2.1 2006/01/24 21:42:36 belinfan Exp $
#
# Author: Axel Belinfante
#
# This file is _VERY_ simular to the primer.tcl file!
# If you change something here, changes are VERY high that you have to
# change it in primer.tcl as well!
#
# This file implements the MUTANT command that we use in guide
# config files.
# The idea is to interpret guide files as tcl files containing
# only invocations of the MUTANT command, to register guides.
# As result of such registration, the GUI will add the registered
# items to the guides menu.
# Question: will the loading of a second guide file override the first one?
# Or can we have items of multiple guide files 'active' at the same time?
# If so, how will this be visible in the menu?
# (as a sub-menu under the Guides menu?)
# How will we be able to 'close' different guide files?
# (via a sub-menu under the Close Guides menu entry?)
#
# =========================================================================

# This routine will be invoked from xtorx to force auto-loading of this file.
proc do_first_initGuides {args} {
	do_first_initExtension $args
}

proc do_initGuides {args} {
	global tester
	global debug

	# set debug(Msg,do_extension_callback) 1
	# set debug(Msg,do_cleanupExtension) 1

	do_initExtension \
		guides \
		GUIDE \
		"*guides" \
		"Open Guides File" \
		tester(guides,titlename) \
		tester(basenamebare,guides_file) \
		tester(torx,cmdline,guides,flags) \
		tester(torx,cmdline,guides,config) \
		"guides_present *guides_mb,*guides,*close_guides_button,*reopen_guides_button" \
		"guides_present *open_guides_button" \
		{
			{{Guides Files}    {.guides}    }
			{{Primers Files}    {.primers}    }
			{{Mutants Files}    {.mutants}    }
			{{Trace Files}      {.trace}      }
			{{Log Files}        {.log}        }
			{{Config Files}     {.if}         }
			{{Text Files}       {.txt}        }
			{{TCL Scripts}      {.tcl}        }
			{{All Files}        *             }
		} \
		$args
}

proc do_cleanupGuides {args} {
	do_cleanupExtension guides $args
}

proc do_open_guides {args} {
	do_open_extension guides $args
}

proc do_do_open_guides { filename} {
	do_do_open_extension guides $filename
}

proc do_close_guides {args} {
	do_close_extension guides $args
}

proc do_do_close_guides {} {
	do_do_close_extension guides
}

proc do_reopen_guides {args} {
	do_reopen_extension guides $args
}

proc do_do_select_guide {titlename} {
	do_do_select_extension guides $titlename
}

proc GUIDE {entry title create destruct args} {
	EXTENSION guides $entry $title $create $destruct $args
}
