# =========================================================================
# $Id: messages.tcl,v 1.1.2.4 2004/10/04 13:30:20 belinfan Exp $
# =========================================================================
#
# A layer on top of the widget access routines, for writing to the
# messages pane
#

proc messages_append {s} {
	global tester
	text_append $tester(text,msg) $s \
		[list $tester(tag,run,current)  \
		       $tester(tag,run,current),$tester(run,stepnr) ]
}

proc messages_show {nr} {
	global tester
	if {![info exists tester(text,msg,backlight)]} {
		set tester(text,msg,backlight) ""
	}
	if {[string compare $tester(text,msg,backlight) step$nr] != 0} {
		text_unbacklight $tester(text,msg) $tester(text,msg,backlight)
		set tester(text,msg,backlight) $tester(tag,run,current),$nr
		text_backlight $tester(text,msg) $tester(text,msg,backlight)
	}
	text_seebacklight $tester(text,msg) $tester(text,msg,backlight)
}


proc messages_init {} {
	global tester

	set tester(name,outline) ""

	set tester(highlightbackground) \#ececec
	set tester(background) \#d9d9d9

	set tester(pointercursor) top_left_arrow

	set tester(tag,image)                 "tag,image"
	set tester(tag,elided)                "tag,elided"
	messages_add_cursor_binding ;# this needs only to be called once
	catch {$tester(text,msg) tag configure $tester(tag,elided) -elide 1}

	
	set tester(light,img,opened,top) [ image create bitmap lightopenedtop -data {
#define openedtop_width 13
#define openedtop_height 13
static unsigned char openedtop_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x07, 0x01, 0x04, 0x02, 0x02,
   0x04, 0x01, 0x88, 0x00, 0x50, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00};
	} ]
	set tester(dark,img,opened,top) [ image create bitmap darkopenedtop -data {
#define top_width 13
#define top_height 13
static unsigned char top_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x07, 0xff, 0x07, 0xfe, 0x03,
   0xfc, 0x01, 0xf8, 0x00, 0x70, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00};
	} ]
	set tester(light,img,opened,bottom) [ image create bitmap lightopenedbottom -data {
#define openedbottom_width 13
#define openedbottom_height 13
static unsigned char openedbottom_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x50, 0x00, 0x88, 0x00,
   0x04, 0x01, 0x02, 0x02, 0x01, 0x04, 0xff, 0x07, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00};
	} ]
	set tester(dark,img,opened,bottom) [ image create bitmap darkopenedbottom -data {
#define bot_width 13
#define bot_height 13
static unsigned char bot_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x70, 0x00, 0xf8, 0x00,
   0xfc, 0x01, 0xfe, 0x03, 0xff, 0x07, 0xff, 0x07, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00};
	} ]
	set tester(light,img,closed) [ image create bitmap lightclosed -data {
#define closed_width 13
#define closed_height 13
static unsigned char closed_bits[] = {
   0x18, 0x00, 0x28, 0x00, 0x48, 0x00, 0x88, 0x00, 0x08, 0x01, 0x08, 0x02,
   0x08, 0x01, 0x88, 0x00, 0x48, 0x00, 0x28, 0x00, 0x18, 0x00, 0x00, 0x00,
   0x00, 0x00};
	} ]
	set tester(dark,img,closed) [ image create bitmap darkclosed -data {
#define side_width 13
#define side_height 13
static unsigned char side_bits[] = {
   0x18, 0x00, 0x38, 0x00, 0x78, 0x00, 0xf8, 0x00, 0xf8, 0x01, 0xf8, 0x03,
   0xf8, 0x01, 0xf8, 0x00, 0x78, 0x00, 0x38, 0x00, 0x18, 0x00, 0x00, 0x00,
   0x00, 0x00};
	} ]

	set tester(img,opened,top) $tester(light,img,opened,top)
	set tester(img,opened,bottom) $tester(light,img,opened,bottom)
	set tester(img,closed) $tester(light,img,closed)
}

proc messages_run_setup {runnr} {
	global tester
	set tester(tag,run,current)           "tag,run,$runnr"
	set tester(tag,outline,current)       "tag,outline,$runnr"
	set tester(tag,outline,text,current)  "tag,outline,text,$runnr"
	set tester(tag,closed,current)        "tag,closed,$runnr"
	set tester(tag,opened,current)        "tag,opened,$runnr"
	set tester(tag,opened,top,current)    "tag,opened,top,$runnr"
	set tester(tag,opened,bottom,current) "tag,opened,bottom,$runnr"
}
proc messages_run_begin {} {
	global tester
	global tk_version

	if {$tk_version >= 8.3} {
		
		messages_add_image closed outline "OUTLINE " \
			[list outline,current closed,current image]
		
		if {[catch {$tester(text,msg) tag configure $tester(tag,outline,current) -elide 1} errMsg]} {
			$tester(text,msg) image configure $tester(run,img,closed) -image {}
		}
		messages_add_showhide_binding closed 0 1
		messages_add_highlight_binding closed
	}
	messages_add_image opened,top run "START " \
		[list run,current opened,current opened,top,current image]
	messages_add_showhide_binding opened 1 0
	messages_add_scrollto_binding opened,top last
	messages_add_highlight_binding opened,top
}

proc messages_run_end {} {
	global tester
	messages_add_image opened,bottom run "END " \
		[list run,current opened,current opened,bottom,current image]
	messages_add_scrollto_binding opened,bottom first
	messages_add_highlight_binding opened,bottom
#	text_append $tester(text,msg) "\n" \
#		[list $tester(tag,run,current) $tester(tag,outline,text,current) ]
	catch {$tester(text,msg) tag raise $tester(tag,elided)}
	catch {unset tester(tag,outline,text,current)}
}

proc messages_outline_update {new_outline} {
	global tester
	set tester(name,outline) $new_outline
	if {[info exists tester(tag,outline,text,current)]} {
		set outline_range \
			[$tester(text,msg) tag prevrange $tester(tag,outline,text,current) end]
		while {![string compare $outline_range ""] == 0} {
			set tags [$tester(text,msg) tag names [lindex $outline_range 0]]
			text_replace $tester(text,msg) \
				[lindex $outline_range 0] [lindex $outline_range 1] \
				$new_outline\n $tags
			set outline_range \
				[$tester(text,msg) tag prevrange $tester(tag,outline,text,current) [lindex $outline_range 0]]
		}
		# make sure that the text that always has to be elided
		# indeed always is elided: the elision tag should be 'on top'
		# tag may not yet be present, so use catch...
		catch {$tester(text,msg) tag raise $tester(tag,elided)}
	}
}

proc messages_add_image {state kind name tags} {
	global tester
	set tester(run,img,$state) \
		[$tester(text,msg) image create end -image $tester(img,$state)]
	text_append $tester(text,msg) $name \
		[list $tester(tag,$kind,current) $tester(tag,elided)]
	text_append $tester(text,msg) "$tester(name,outline)\n" \
		[list $tester(tag,$kind,current) $tester(tag,outline,text,current)]
	foreach t $tags {
		$tester(text,msg) tag add $tester(tag,$t) $tester(run,img,$state)
	}
}

proc messages_add_showhide_binding {state run outline} {
	global tester
	$tester(text,msg) tag bind $tester(tag,$state,current) <Button-1> \
		"catch {$tester(text,msg) tag configure $tester(tag,run,current) -elide $run}
		 catch {$tester(text,msg) tag configure $tester(tag,outline,current) -elide $outline}
		 catch {$tester(text,msg) tag configure $tester(tag,elided) -elide 1}
		 catch {$tester(text,msg) tag raise $tester(tag,elided)}
		"
}

proc messages_add_cursor_binding {} {
	global tester
	$tester(text,msg) tag configure $tester(tag,image) -relief raised -borderwidth 2
	$tester(text,msg) tag bind $tester(tag,image) <Enter> \
		"wcDoSetCursor $tester(text,msg) $tester(pointercursor)"
	$tester(text,msg) tag bind $tester(tag,image) <Leave> \
		"wcDoResetCursor $tester(text,msg)"
}

proc messages_add_scrollto_binding {state to} {
	global tester
	$tester(text,msg) tag bind  $tester(tag,$state,current) <Button-2> \
		"$tester(text,msg) see $tester(tag,run,current).$to"
}

proc messages_add_highlight_binding {state} {
	global tester
	$tester(text,msg) tag bind $tester(tag,$state,current) <Enter> \
		"$tester(text,msg) tag configure $tester(tag,$state,current) -background $tester(highlightbackground)"
	$tester(text,msg) tag bind $tester(tag,$state,current) <Leave> \
		"$tester(text,msg) tag configure $tester(tag,$state,current) -background $tester(background)"
}

# =========================================================================
