# =========================================================================
#
# Error handling
#

proc do_stop {} {
	global maininfo
	set maininfo(stopnow) 1
}
proc do_cleanup {} {
	global iutinfo specinfo sidinfo
	foreach id $specinfo(primerids) {
		if {[info exists sidinfo(spec,$id)]} {
			if {[string length $sidinfo(spec,$id)] > 0} {
				catch {send -i $sidinfo(spec,$id) "C_QUIT\r"}
			}
			foreach pid [list $specinfo(pid,$id)] {
				catch {send_error "Cleaning up: $pid\n"}
				if {[string length $pid]} {
					if {[catch {exec kill $pid} foo]} {
						send_error "kill $pid: $foo\n"
					}
					if {[catch {exec kill -9 $pid} foo]} {
						send_error "kill-9 $pid: $foo\n"
					}
				}
			}
		}
	}
}
proc clean_exit { {r 0} } {
	do_cleanup
	exit $r
}
proc fatal { {s ""} } {
	set l [string length $s]
	set timeout 1
	catch { expect }
	if {$l != 0} {
		if {[string compare [string index $s [expr $l - 1]] "\n"] == 0} {
			send_error "Fatal: $s"
		} else {
			send_error "Fatal: $s\n"
		}
	}
	clean_exit 1
}

# =========================================================================
