%{
#if ! (defined(lint) || defined(SABER) || defined(CODECENTER))
static char expry_yAccesSid[] = "@(#)$Id: expry.y,v 1.4 2000/03/08 15:24:40 feenstra Exp $";
#endif

#include <stdio.h>
#include "k.h"
#include "expry.h"
#include "expr.h"
%}

/* VALUE-EXPRESSION: CONCRETE SYNTAX */

%token	CLOSE_PARENTHESIS	EQUAL			FORALL
%token	IDENTIFIER		OPEN_PARENTHESIS	SEMICOLON
%token	SPECIAL_IDENTIFIER	UNDERSCORE		WHITESPACE
%token  OFSORT			COMMA			STAR
%token  QUERY			EXCLAM			OPEN_BRACE
%token	CLOSE_BRACE

/* no yt_operation/yt_sort/... identifiers */

%type <yt_ut_term>			expression
%type <yt_ut_term>			simple_expression
%type <yt_ut_terms>			expression_list
%type <yt_nocasestring>		operation_identifier
%type <yt_nocasestring>		identifier
%type <yt_nocasestring>		special_identifier
%type <yt_nocasestring>		IDENTIFIER
%type <yt_nocasestring>		SPECIAL_IDENTIFIER
%type <yt_ut_experiments>	experiment_list
%type <yt_ut_experiment>	experiment

%%

/*----------------------------------------------------------------------*/
/* GOALS								*/
/*----------------------------------------------------------------------*/

root:
	/* empty */
		{ parser_result = UT_NoEvent(); }
|	identifier experiment_list
		{ if (eq_nocasestring(mknocasestring("i"), $1)) {
			parser_result = UT_YesEvent( UT_Event( UT_Internal(), $2 ));
		  } else {
			parser_result = UT_YesEvent( UT_Event( UT_External( $1 ), $2 ));
		  }
		}
	;

/*----------------------------------------------------------------------*/
/* EXPRESSIONS								*/
/*----------------------------------------------------------------------*/

expression:
	  expression operation_identifier simple_expression
		{ $$ = UT_FunctionTerm($2,Consut_terms($1,Consut_terms($3,Nilut_terms()))); }
	| simple_expression
		{ $$ = $1; }
	;

simple_expression:
	operation_identifier OPEN_PARENTHESIS expression_list CLOSE_PARENTHESIS
		{ $$ = UT_FunctionTerm($1,$3); }
	| identifier /* variable or constant */
		{ $$ = UT_FunctionTerm($1, Nilut_terms()); }
	| special_identifier
		{ $$ = UT_FunctionTerm($1, Nilut_terms()); }
	| OPEN_PARENTHESIS expression CLOSE_PARENTHESIS
		{ $$ = $2; }
	;

expression_list:
	expression_list COMMA expression 
		{ $$ = add_ut_term_behind($1,$3); }
	| expression
		{ $$ = Consut_terms($1, Nilut_terms()); }
	| /* empty */
		{ $$ = Nilut_terms(); }
	;

/*----------------------------------------------------------------------*/
/* IDENTIFIERS								*/
/*----------------------------------------------------------------------*/

operation_identifier:
	   special_identifier
		{ $$ = $1; }
	| identifier
		{ $$ = $1; }
	;

identifier:	IDENTIFIER
		{ $$ = $1; }
	;

special_identifier:
	SPECIAL_IDENTIFIER
		{ $$ = $1; }
	;


/*----------------------------------------------------------------------*/
/* EXPERIMENTS								*/
/*----------------------------------------------------------------------*/

experiment_list :
		experiment_list experiment
		{ $$ = add_ut_experiment_behind($1,$2); }
		|
		experiment
		{ $$ = Consut_experiments($1,Nilut_experiments()); }
		|
		{ $$ = Nilut_experiments(); }
		;

experiment :
		EXCLAM expression
		{ $$ = UT_Experiment( $2 ); }
		|
		QUERY expression
		{ $$ = UT_Experiment( $2 ); }
		;
%%

/*----------------------------------------------------------------------*/
/* YACC ROUTINES							*/
/*----------------------------------------------------------------------*/

int yyerror(s)
    char *s;
    {
    char a_message[256];

	sprintf( a_message, "%s at line %d, near position %d", s, yylineno, yycolno );
	parser_error = 1;
    }


int yywrap()
    {
    return 1;
    }

/************************************************************************/
/* BLUSH YACC								*/
/************************************************************************/
