# =========================================================================
# $Id: random.tcl,v 1.1.2.1 2000/08/28 12:12:07 belinfan Exp $
# =========================================================================

proc random {range} {
	# return [expr [ clock clicks] % $range]
	return [RandomRange $range]
}

# =========================================================================

# Random number generator taken from:
#
# Brent Welch, "Practical Programming in Tcl/Tk", 2nd edition, pages 78,79
#   (adapted from Don Libes, "Exploring Expect", 1995 and from
#                 Press et al. "Numerical Recipes in C", 1998
#   )
#
proc RandomInit {seed} {
	global randomSeed
	set randomSeed $seed
}

proc Random {} {
	global randomSeed
	set randomSeed [expr ($randomSeed*9301 + 49297) % 233280]
	return [expr $randomSeed/double(233280)]
}

proc RandomRange {range} {
	return [expr int ([Random]*$range)]
}

# =========================================================================
