/***** trojka: tan-engine.c *****/

/* Copyright (c) 1991,1995 by AT&T Corporation.  All Rights Reserved.     */
/* This software is for educational purposes only.                        */
/* Permission is given to distribute this code provided that this intro-  */
/* ductory message is not removed and no monies are exchanged.            */
/* No guarantee is expressed or implied by the distribution of this code. */
/* Software written by Gerard J. Holzmann as part of the book:            */
/* `Design and Validation of Computer Protocols,' ISBN 0-13-539925-4,     */
/* Prentice Hall, Englewood Cliffs, NJ, 07632.                            */
/* Send bug-reports and/or questions to: gerard@research.att.com          */
/*	Modified code and additional routines for the trojka analyser	  */
/*	No guarantee is expressed or implied!				  */
/*									  */
/* No permission is given to distribute the modified code and		  */
/* additional routines without permission of the author.		  */
/*									  */
/* Modified code and additional routines written by Rene G. de Vries	  */
/**************************************************************************/
/* trojka analyser engine						
/* version 1.0 :	Tue Jun 11 20:32:02 MET DST 1996		
 * version 2.0b:        Thu Nov 14 17:06:36 MET 2002             
 *                      cleaned and making it tarjan            
 * version 2.1:         Thu Jun 17 13:24:33 CEST 2004
 *                      code cleanup.
 *
 *
 */
/*------------------------------------------------------------------------*/

#include "tan.r"

char
dotransition(Trans *t, short II, int n)
{	char m;
	short tt = (short) ((P0 *) pptr(II))->_p;
#define continue	return 0
#define this 		pptr(II)
#include "tan.m"
P999:	return 1;
#undef continue
#undef this
}

void
undotransition(Trans *t, short II, int n)
{	char m;
	short   tt = (short) ((P0 *) pptr(II))->_p;
#define continue goto R999
#define this	pptr(II)
#include "tan.b"
R999: /*EMPTY*/ ; /* AFEB added this semicolon */
#undef continue
#undef this
}
		
void
do_with_spec(	StateSetT **superstate, /*inout: superstate */
		uchar com,		/*in: command */	
		uchar *gamma		/*out: deltasuspension */
		)
/* predict all possible action from a state
   in: superstate vector representing the reduced observed state. 
	com   : in - command (ADD/AMOVE/DMOVE)
	gamma : out - true is a deltasuspention is found
 
*/

{
int		actioncounter = 0;
#ifdef RGVTEXT
int		counter_S;
char *lmsg; /* nice info for logging */
#endif
int		diepte, i, dieptewarned;
short		firstproc = 0;
short		lastproc;
uchar		delta, inaction;
char		n;		/* no idee what this does */
short		Pselect,	/* selected process */
		Pprocstate;	/* state of selected process */
char		Pproctype;	/* type of selected process */
Trans		*option;	/* action to execute */
uchar		*action;	/* pointer to variables in statevector */
StateSetT	*sstate	= NULL,	/* current selected element from superstate */ 
		*Temp	= NULL,		/* temporal */
		*Result	= NULL;		/* result after action-execution */

Trelease();	/* start all over with hashing, i.e. Mathed set is empty */
cut = 0;	/* cuts initial zero */
reacheddepth = 0;
executed = 0;
matched = 0;
analyse = 0;	/* intial zero */
*gamma = 0;	/* initial no delta-suspension */
dieptewarned = 0;

#ifdef RGVTEXT

counter_S = 0; /* for counting superstates logging */

switch (com) {
   case ADD: lmsg="Engine command: searching for Menu";break;
   case AMOVE: lmsg="Engine command: determing S'=S AFTER x";break;
   case DMOVE: lmsg="Engine command: termining S'=S AFTER Quienscence";break;
}
logprintf(">T-Engine< superstate S has %d elements\n\t %s\n",
SSnrel(superstate),lmsg);

#endif /* ifdef RGVTEXT */

for (sstate=*superstate;sstate;sstate=sstate->nxt) {
   ResState(sstate);	/* set context */

#ifdef RGVTEXT
   counter_S++;
   logprintf(">T-Engine< Select superstate element %d\n",counter_S);
#endif /* ifdef RGVTEXT */

   if (com==DMOVE) SSclear(&Temp);
   diepte = 0;
   firstproc = 0;
   lastproc = now._nr_pr-1;

Beneden:
   if (Maxdiepte && (diepte >= Maxdiepte))
   {

	
   if (!dieptewarned) {
       fprintf(stderr, "Cut of branch at depth %d; use -m flag to increase search depth\n",diepte);
       dieptewarned = 1;
   }
#ifdef RGVTEXT
   logprintf(">T-Engine< Cut of branche at depth %d \n",diepte);
#endif
   cut++;
   goto Omhoog;
   }

   if (firstproc==0)
     if (Thit(&now, vsize, proc_offset, q_offset, &delta))
       {
	 matched++;

	 if (diepte > 0) {

#ifdef RGVTEXT
	 logprintf(">T-Engine< state collision: (regular) state already done \n");
#endif

	 goto Omhoog;
	 } else {  

#ifdef RGVTEXT
	   logprintf(">T-Engine< state collision: super state already done \n");
#endif
	   continue;
	 }
       }
  		
   /* mark state that is under investigation (state matching ala tarjan */

   Tstore(&now, vsize, proc_offset, q_offset, delta);   
   delta = 1;	/* PAS HIER ANDERS FOUTEN ! */
   analyse++;	/* increment nr of analysed states */

#ifdef RGVTEXT
   logprintf(">T-Engine< current state: %d processes\n",lastproc);
#endif 

Wederom:
   for (Pselect = lastproc; Pselect >= firstproc; Pselect -= 1)
     {
#ifdef RGVTEXT
       logprintf(">T-Engine< Select process %d, investigating options\n",Pselect);
#endif 
       action = pptr(Pselect);
       Pproctype = (unsigned char) ((P0 *) action)->_t;
       Pprocstate = (short) ((P0 *) action)->_p;		
       trpt->o_pm &=  0; /* no move in this pid yet, supports else */
       for (option = trans[Pproctype][Pprocstate];option;option=option->nxt) 
	 {
	   transact(option,Pselect,n,OBS);	/* set observable variable */
	   switch (observable) {

	   case INPUT:
#ifdef RGVTEXT
	     logprintf(">T-Engine< depth %d, selected process %d, obs.input action %s [%d], else is %s possible\n",
		       diepte, Pselect, option->tp, option->forw,
		       (trpt->o_pm&1)?"not":"still");
#endif				
	     trpt->o_pm |= 1; /* we moved (else solver */
	     switch (com) {
	     case DMOVE:
	       inaction = 1;
	       break; /* case INPUT/DMOVE */
	     case ADD:
	       transact(option,Pselect,n,ADD);
	       break; /* case INPUT/ADD */
	     case AMOVE:
	       if (fldval[0] > 0) { /* input move ? */
		 IncludeState(&Temp);
		 if (transact(option,Pselect,n,MOVE)) {
		   executed++;
		   if (option->st) /* MOVE */
		     ((P0 *)action)->_p = option->st;
		   IncludeState(&Result);
		 } 
		 ResState(Temp);
		 SSclear(&Temp); /* restore context to return */
	       }
	       break; /* case INPUT/AMOVE */

	     }
	     break; /* case INPUT */

	   case OUTPUT:
#ifdef RGVTEXT
	     logprintf(">T-Engine< depth %d, selected process %d, obs.output action %s [%d], else is %s possible\n",
		       diepte, Pselect, option->tp, option->forw,
		       (trpt->o_pm&1)?"not":"still");
#endif
	     trpt->o_pm |= 1; /* we moved (else solver */
	     switch (com) {
	     case ADD:
	       transact(option,Pselect,n,ADD);
	       break;
	     case DMOVE:
	       delta = 0;
	       break;
	     case AMOVE:
	       if (fldval[0] < 0) { /* output move ? */
		 IncludeState(&Temp);
		 if (transact(option,Pselect,n,MOVE)) {
		   executed++;
#ifdef RGVTEXT
		   fprintf(stderr, "Execute action: %s\n",option->tp);
#endif
		   if (option->st) /* MOVE */
		     ((P0 *)action)->_p = option->st;
		   IncludeState(&Result);
		 }
		 ResState(Temp);
		 SSclear(&Temp); /* restore context to return */
	       }
	       break;
	     }
	     delta= 0;
	     break; /* OUTPUT */
			
	   case BLOCKED:	{
#ifdef RGVTEXT
	     logprintf(">T-Engine< Selected process %d, blocked action %s [%d], else is %s possible\n",
		       Pselect, option->tp, option->forw, (trpt->o_pm&1)?"not":"still");
#endif
	     break; /* no inout nor output during RV-SYNC */
	   }
			
	   case TAU:			                
	     if (!dotransition(option,Pselect,n)){
#ifdef RGVTEXT
	       logprintf(">T-Engine< depth %d, selected process %d, non executable tau action %s [%d], else is %s possible\n",
			 diepte, Pselect, option->tp,
			 option->forw, (trpt->o_pm&1)?"not":"still");
#endif
	       break; /* TAU */
	     }

	     else {
	       trpt->o_pm |= 1; /* we moved (else solver) */
#ifdef RGVTEXT
	       logprintf(">T-Engine< depth %d,selected process %d, executable tau action %s [%d], else is %s possible\n",
			 diepte, Pselect, option->tp, option->forw,
			 (trpt->o_pm&1)?"not":"still");
#endif

	       /* support for the new definition of ioco
		*
		* subtile handling of boq-quiescence */
	       /* only mark quiescence when we are not blocked in a RV; this state was unstable  */
	       /* we only set the delta in going up; because of the the RV handing.
		 delta = 0; 		
	       */ 

	       diepte++;depth++;trpt++;

	       /* do some bookkeeping */
	       trpt->pr = Pselect; trpt->st = Pprocstate;
	       if (option->st) /* setting new state */
		 ((P0 *)action)->_p = option->st;

	       trpt->o_t = option;trpt->o_n = n;
	       trpt->o_ot = Pproctype; trpt->o_tt = Pprocstate;
	       trpt->o_To = firstproc;
	       trpt->o_delta = delta; trpt->o_inaction = inaction;

	       if (option->atom&2) /* atomic action */
		 {lastproc=firstproc=Pselect;nlinks++;}
	       else { lastproc = now._nr_pr-1; firstproc = 0;}	

	       goto Beneden;	
					}
	   } /* switch observable */
	   continue;

Omhoog:	/* restore last state bookkeeping */
	   option = trpt->o_t /* restore old option for undo */;

#ifdef RGVTEXT
	   logprintf(">T-Engine< Current state investigated, going backwards depth %d => depth %d\n",
		     diepte, diepte-1);
#endif
	   /* okay we are going up;
	    * are we now in a RV case; so then no quiensce should be detected.
	    * otherwise we always can conclude that there was a tau; so instable state
	    * and delta should be set.
	    */
	   if (boq==-1)
	     delta = 0; /* always since there was an internal step */
	   n = trpt->o_n /* no idee, but do it anyway */;
	   Pproctype = trpt->o_ot /* restore old proctype */;
	   Pprocstate = trpt->o_tt /* restore old procstate */;
	   Pselect = trpt->pr; /*restore old procselected */;

	   action = pptr(Pselect);
	   firstproc = trpt->o_To; /* restore old firstproc */;
	   undotransition(option,Pselect,n); /* undo action */;
	   depth--;trpt--;diepte--;
	   ((P0 *)action)->_p = Pprocstate;

	 } /* all options */
     } /* all processes */


if (boq == -1) {
  /* only add state when we are in nonblocked mode (boq) */
  *gamma = (*gamma || delta); /* set delta */

  if (com==DMOVE && delta) {
    IncludeState(&Result);	/* this should be delivered */	
  }
}

 if (reacheddepth < diepte) reacheddepth = diepte;	

 if (diepte >0) goto Omhoog /* stack is not empty */;

 if (com==DMOVE) SSmerge(&Result,&Temp);	/* add pending results */

} /* all superstate-elements */

 if (com==DMOVE || com==AMOVE) {
   SSclear(superstate);
   SSmerge(superstate,&Result);	/* return result */
 }
}
