/***** trojka: tan-sman.h *****/

/* Copyright (c) 1991,1995 by AT&T Corporation.  All Rights Reserved.     */
/* This software is for educational purposes only.                        */
/* Permission is given to distribute this code provided that this intro-  */
/* ductory message is not removed and no monies are exchanged.            */
/* No guarantee is expressed or implied by the distribution of this code. */
/* Software written by Gerard J. Holzmann as part of the book:            */
/* `Design and Validation of Computer Protocols,' ISBN 0-13-539925-4,     */
/* Prentice Hall, Englewood Cliffs, NJ, 07632.                            */
/* Send bug-reports and/or questions to: gerard@research.att.com          */

/*	Modified code and additional routines for the trojka analyser	*/
/*	No guarantee is expressed or implied!				*/
/*									*/
/* No permission is given to distribute the modified code and		*/
/* additional routines without permission of the author.		*/
/*									*/
/* Modified code and additional routines written by Rene G. de Vries	*/
/*									*/
/* trojka analyser state manager					*/
/* version 1.0 :	Tue Jun 11 20:32:02 MET DST 1996		*/

#ifndef H_TAN_SMAN
#define H_TAN_SMAN

#ifndef uchar
#define uchar	unsigned char
#endif

#if 0

/* === declare extern globals from tan.c (executed in tan-sman.c) === */
extern	int	j1;		/* hash value (result of s_hash) */
extern	int	ssize;		/* 2^ssize hash table entries */
extern	int	mask;		/* 2^ssize - 1 */
extern	int	truncs;		/* match counter */
extern	int	hcmp;		/* hash conficts counter */	

/* === declare extern procedures/functions from tan.c === */
void	s_hash(uchar*, int);	/* hash function */
char	*emalloc(unsigned);	/* never released or reallocated memory proc */

#endif

/* === declaration of datatypes === */

typedef struct StateStrT {		/* datatype to store state structure */
	unsigned short	nr_users;		/* #user using this item */
	int 		proc_struct[MAXPROC];	/* copy of pan's proc_offset */
	int		q_struct[MAXQ];		/* copy of pan's q_offset */
	struct StateStrT *nxt;			/* double-linked list */
	struct StateStrT *last;		
} StateStrT;

typedef struct StateSetT{	/* datatype to store a states */
	short firstproc;		/* parameter for atomic move */
	short lastproc;			/* parameter for atomic move  */
        int vsize;      		/* length of the selected state */
        char *body;     		/* pointer to a stored state */
        uchar delta;    		/* room for output-suspension info */
	struct StateStrT *struc;	/* pointer to structure	of the state */
        struct StateSetT *nxt;	
} StateSetT;

/* === prototypes and exported functions/procedures === */

void
SSaddstate(	StateSetT**,	/* A		(io) */ 
	 	State*,		/* state	(in) */
	 	int,		/* size		(in) */
		char*,		/* proc_offset	(in) */
		char*,		/* q_offset	(in) */
		uchar		/* delta	(in) */
	);
/* includes state with parameters size, proc_offset, q_offset and delta in A */


void
SSclear (
	StateSetT**			/* A (io) */
	);
/* empties the stateset A*/


void
SSmerge	(
	StateSetT**,			/* A (io) */
	StateSetT**			/* B (io) */
	);
/* includes stateset B in A and empties set B */

int
SSnrel (
	StateSetT**			/* A (in) */
	);
/* return the number of elements in stateset A */ 

void
Tinit(void);
/* initialize the hash table */


void 
Trelease();
/* reinstall the hash table (clears all entries) */

void
Tstore(	State*		/* in: state */, 
	int,		/* in: size of statevector */
	int*,		/* in: p_offset */
	int*,		/* in: q_offset */
	uchar);		/* in: delta */
/* stores the statevector with parameters into hash-table */


int
Thit(	State*		/* in: state */, 
	int,		/* in: size of statevector */
	int*,		/* in: p_offset */
	int*,		/* in: q_offset */
	uchar*);	/* out: delta */
/* checks if statevector with parameters is already a member of hash_table */
/* returns 0 if not so, unequal to 0 otherwise */
/* if already a member: delta gets stored value */

void   
IncludeState(StateSetT** /* inout: Set */);
/* saves state and context in Set  */

void
ResState(StateSetT* /* in: State */);
/* restores state State in now ect. */




#endif
